
# DO NOT EDIT THIS FILE -- AUTOGENERATED BY PANTS
# Target: src/ai/backend/test:dist

from setuptools import setup

setup(**{
    'author': 'Lablup Inc. and contributors',
    'classifiers': [
        'Intended Audience :: Developers',
        'Operating System :: MacOS :: MacOS X',
        'Operating System :: POSIX :: Linux',
        'Programming Language :: Python',
        'Programming Language :: Python :: 3',
        'Environment :: No Input/Output (Daemon)',
        'Topic :: Scientific/Engineering',
        'Topic :: Software Development',
        'Development Status :: 5 - Production/Stable',
        'Programming Language :: Python :: 3.13',
        'License :: OSI Approved :: MIT License',
    ],
    'description': 'Backend.AI Integration Test Suite',
    'entry_points': {
        'backendai_cli_v10': [
            'test = ai.backend.test.cli.__main__:main',
        ],
    },
    'install_requires': (
        'aiofiles~=24.1.0',
        'aiohttp~=3.11.16',
        'aiotools~=1.9.0',
        'attrs>=25.3',
        """backend.ai-cli==25.11.0
""",
        """backend.ai-client==25.11.0
""",
        """backend.ai-common==25.11.0
""",
        """backend.ai-logging==25.11.0
""",
        """backend.ai-plugin==25.11.0
""",
        'click~=8.1.7',
        'pydantic[email]~=2.11.3',
        'pytest-dependency>=0.6.0',
        'pytest>=8.3.3',
        'tomli~=2.0.1',
        'types-aiofiles',
        'types-setuptools',
    ),
    'license': 'MIT',
    'long_description': """# Backend.AI Testing Toolkit

Automated test suites to validate an installation and integration of clients and servers


## How to run CLI-based integration test

If there is no configuration script named `env-tester.sh`, copy it from `sample-env-tester.sh` and check the configuration env.

```console
$ source env-tester.sh
$ backend.ai test run-cli
```

NOTE: The ENV script is parsed with `"^export (\w+)=(.*)$"` regex pattern line by line.
""",
    'long_description_content_type': 'text/markdown',
    'name': 'backend.ai-test',
    'namespace_packages': (
    ),
    'package_data': {
        'ai.backend.test': (
            'VERSION',
            'py.typed',
        ),
    },
    'packages': (
        'ai.backend.test',
        'ai.backend.test.cli',
        'ai.backend.test.contexts',
        'ai.backend.test.data',
        'ai.backend.test.templates',
        'ai.backend.test.templates.auth',
        'ai.backend.test.templates.model_service',
        'ai.backend.test.templates.session',
        'ai.backend.test.templates.user',
        'ai.backend.test.templates.vfolder',
        'ai.backend.test.testcases',
        'ai.backend.test.testcases.auth',
        'ai.backend.test.testcases.model_service',
        'ai.backend.test.testcases.session',
        'ai.backend.test.testcases.session.multi_node_multi_container',
        'ai.backend.test.testcases.session.single_node_multi_container',
        'ai.backend.test.testcases.session.single_node_single_container',
        'ai.backend.test.testcases.vfolder',
        'ai.backend.test.tester',
        'ai.backend.test.utils',
    ),
    'project_urls': {
        'Documentation': 'https://docs.backend.ai/',
        'Source': 'https://github.com/lablup/backend.ai',
    },
    'python_requires': '>=3.13,<3.14',
    'url': 'https://github.com/lablup/backend.ai',
    'version': """25.11.0
""",
    'zip_safe': False,
})
